Subject: [RFC] A Change to Commit IDs Too Ridiculous to Consider?

From: Jon Forrest <[email-masked]>
Date: Sun, 24 Jul 2016 11:12:12 -0700

Those of us who write instructional material about Git all face the same problem.
This is that we can't write step by step instructions that show the results of
making a commit because users will always see different commit IDs.
This is fundamental to the design of Git.

Even if the instructional material tells users to use standard author and committer
information, (e.g. [email-masked]) and shows the text of the file being committed
and the commit message to add, the resulting commit ID will differ from reader to reader
since the commit will presumably take place at different times.

What if it were possible, for instructional purposes only, to somehow tell Git to relax
this requirement. By this I mean, the commit date would *not* be included when constructing
the commit ID. This would allow tutorials to show exactly what to expect to see when running commands.

I realize that questions would remain such as how to turn on this behavior (e.g. command line flags,
environment variables) and whether 'git log' (and maybe other commands) should somehow distinguish these
mutant commits. There would probably be other issues to consider.

Again, this is for instructional purposes only, and only when the committer explicitly
chooses to use this option. I'm *not* proposing a general change to Git's behavior.

Is such a thing to ridiculous to even consider? Is there a better way to achieve the same result?

Jon Forrest